## psi4 0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)

# Declare project name and programming languages
project(psi4 CXX C)

# Custom CMake modules location
list(APPEND CMAKE_MODULE_PATH
     ${CMAKE_SOURCE_DIR}/cmake
     ${CMAKE_SOURCE_DIR}/cmake/compilers
     ${CMAKE_SOURCE_DIR}/cmake/math
     ${CMAKE_SOURCE_DIR}/cmake/testing
     )

#  Options
option(ENABLE_BOUNDS_CHECK   "Enable bounds check"                         OFF)
option(ENABLE_MPI            "Enable MPI parallelization"                  OFF)
option(ENABLE_OMP            "Enable OpenMP parallelization"               ON)
option(ENABLE_UNIT_TESTS     "Enable compilation of unit test suite"       OFF)
option(ENABLE_AUTO_BLAS      "Enable CMake to autodetect BLAS"             ON)
option(ENABLE_AUTO_LAPACK    "Enable CMake to autodetect LAPACK"           ON)
option(ENABLE_ACCELERATE     "Enable use of Mac OS X Accelerate Framework" OFF)
option(ENABLE_CSR            "Enable MKL compressed sparse row"            OFF)
option(ENABLE_SCALAPACK      "Enable SCALAPACK"                            OFF)
option(ENABLE_SCALASCA       "Enable scalasca profiler mode"               OFF)
option(ENABLE_STATIC_LINKING "Enable mostly static libraries linking"      OFF)
option(ENABLE_XHOST          "Enable processor-specific optimizations"     ON)
option(ENABLE_GPU_DFCC       "Enable GPU-DFCC plugin"                      OFF)
option(ENABLE_PLUGINS        "Enable compilation of example plugins"       OFF)
option(ENABLE_DUMMY_PLUGIN   "Enable dummy plugin"                         OFF)
option(ENABLE_CHEMPS2        "Enable CheMPS2 for DMRG"                     OFF)
option(ENABLE_CXX11_SUPPORT  "Enable C++11 compiler support"               ON)
# Modules requiring Fortran
if(ENABLE_LIBERD OR ENABLE_PCMSOLVER OR ENABLE_JKFACTORY OR ENABLE_DKH)
   if(NOT CMAKE_Fortran_COMPILER)
      message(FATAL_ERROR "The Fortran compiler has to be explicitly specified!")
   endif()
endif()
include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(
       ENABLE_DKH            "Enable DKH in libmints"                      ON
                             "CMAKE_Fortran_COMPILER"                      OFF)
CMAKE_DEPENDENT_OPTION(
       ENABLE_PCMSOLVER      "Enable PCMSolver library"                    OFF
                             "CMAKE_Fortran_COMPILER"                      OFF)
CMAKE_DEPENDENT_OPTION(
       ENABLE_LIBERD         "Enable use of LibERD instead of LibInts"     OFF
                             "CMAKE_Fortran_COMPILER"                      OFF)
# Options for dashboard builds
option(ENABLE_CODE_COVERAGE  "Enable code coverage"                        OFF)
option(ENABLE_MEMCHECK       "Enable Valgrind memory check"                OFF)
option(ENABLE_ASAN           "Enable address sanitizer"                    OFF)
option(ENABLE_MSAN           "Enable memory sanitizer"                     OFF)
option(ENABLE_TSAN           "Enable thread sanitizer"                     OFF)
option(ENABLE_UBSAN          "Enable undefined behaviour sanitizer"        OFF)
option(ENABLE_JKFACTORY      "Enable the distributed JKFactory (requires MPI)"            OFF)

set(EXTERNAL_LIBS)

# Decide if Fortran is needed
if(ENABLE_LIBERD OR ENABLE_PCMSOLVER OR ENABLE_JKFACTORY OR ENABLE_DKH)
   enable_language(Fortran)
   # add_definitions(-DHAVE_FORTRAN)  # unused
   # This is to use the CMake generated macros and not those based on FC_SYMBOL
   add_definitions(-DUSE_FCMANGLE_H)
   set(FORTRAN_ENABLED TRUE)
   message(STATUS "Fortran ENABLED")
endif()

# Include CMake modules as needed
include(ConfigVersion)
include(ConfigArchitecture)
include(ConfigCompilerFlags)
include(PerTargetCompilerFlags) # This module has to be included **after** ConfigCompilerFlags.cmake
include(ConfigOMP)

# Math: find BLAS and LAPACK
set(BLAS_LANG   "CXX")
set(BLAS_FOUND FALSE)
set(LAPACK_LANG "CXX")
set(LAPACK_FOUND FALSE)
set(MKL_COMPILER_BINDINGS "${CMAKE_CXX_COMPILER_ID}")
include(ConfigMath)

include(ConfigMPI)
include(ConfigExplicitLibs)
include(ConfigSafeGuards)
include(GenericMacros)
#include(BinaryInfo)
#include(mergestaticlibs)
include(CheckIncludeFiles)
include(CheckFunctionExists)
# Here we look for Perl, Sphinx, Doxygen and LaTeX
include(ConfigDocumentation)
# Access to the fortran_enabler macro
include(FortranEnabler)

if(NOT FORTRAN_ENABLED)
   # For linking to math subroutines use the FC_SYMBOL strategy, if Fortran was not enabled
   set(FC_SYMBOL 2)
   add_definitions(-DFC_SYMBOL=${FC_SYMBOL})
endif()

if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local/psi4")
   set(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT TRUE CACHE INTERNAL "")
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set(CMAKE_INSTALL_PREFIX ${PROJECT_BINARY_DIR}/interfaces)
   set(EXTERNAL_PROJECT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
   set(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT ${CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT} CACHE INTERNAL "")
else()
   set(EXTERNAL_PROJECT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/interfaces)
   set(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT ${CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT} CACHE INTERNAL "")
endif()

# This section attempts to find some system libraries:
#  a. libutil : needed for linking against static libpython (Linux only)
#  b. libm    : needed for lib{int,deriv}_compiler (Linux only)
#  c. librt   : needed for the timers (Linux only)
#  d. libdl   : needed for dynamic linking (Linux and Mac OS X)
#  e. Threads   (Linux and Mac OS X)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   find_package(Util REQUIRED)
   include_directories(SYSTEM "${LIBUTIL_INCLUDE_DIR}")
   link_libraries("${LIBUTIL_LIBRARIES}")

   find_package(M REQUIRED)
   include_directories(SYSTEM "${LIBM_INCLUDE_DIR}")
   link_libraries("${LIBM_LIBRARIES}")

   find_package(RT REQUIRED)
   include_directories(SYSTEM "${LIBRT_INCLUDE_DIR}")
   link_libraries("${LIBRT_LIBRARIES}")
endif()

find_package(DL REQUIRED)
if(LIBDL_FOUND)
   set(HAVE_DLFCN_H "1")
   include_directories(SYSTEM "${LIBDL_INCLUDE_DIR}")
   link_libraries("${LIBDL_LIBRARIES}")
endif()

find_package(Threads REQUIRED)
link_libraries("${CMAKE_THREAD_LIBS_INIT}")

# Python Detection
include(ConfigPython)
link_libraries("${PYTHON_LIBRARIES}")
include_directories(SYSTEM "${PYTHON_INCLUDE_DIRS}")

# Boost Detection
# We need Boost.Python, so this has to come _after_ Python detection
include(ConfigBoost)
link_directories("${Boost_LIBRARY_DIRS}")
include_directories(SYSTEM "${Boost_INCLUDE_DIRS}")

# CheMPS2 Detection
if(ENABLE_CHEMPS2)
   include(ConfigChemps2)
endif()

# Append the suffix given from input to all generated executables
if(EXECUTABLE_SUFFIX)
   set(CMAKE_EXECUTABLE_SUFFIX "${EXECUTABLE_SUFFIX}")
   message(STATUS "Suffix ${CMAKE_EXECUTABLE_SUFFIX} will be appended to executables")
endif()

if(LDFLAGS)
   set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LDFLAGS}")
endif()

if(ENABLE_PLUGINS)
   message(STATUS "Plugins support ENABLED")
endif()

# MKL_Free_Buffers NEEDS TO BE TESTED
check_function_exists(MKL_Free_Buffers HAVE_MKL)

# Detection of erf, __builtin_expect, __builtin_prefetch, __builtin_constant_p
# This step is skipped for GCC and Clang: they are all defined but for some reasons not detected by CMake
if(CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Clang)
   set(HAVE_BUILTIN_EXPECT     TRUE)
   set(HAVE_BUILTIN_PREFETCH   TRUE)
   set(HAVE_BUILTIN_CONSTANT_P TRUE)
   set(HAVE_FUNC_ERF           TRUE)
else()
   # Check that __builtin_expect is available
   check_function_exists(__builtin_expect HAVE_BUILTIN_EXPECT)
   # Check that __builtin_prefetch is available
   check_function_exists(__builtin_prefetch HAVE_BUILTIN_PREFETCH)
   # Check that __builtin_constant_p is available
   check_function_exists(__builtin_constant_p HAVE_BUILTIN_CONSTANT_P)
   # Error function
   check_function_exists(erf HAVE_FUNC_ERF)
endif()

if(NOT HAVE_FUNC_ERF)
   message(FATAL_ERROR "ERF was not found")
endif()

if(ENABLE_LIBERD)
   message(WARNING "Building/Using LibERD instead of LibInts!!!!")
   add_definitions(-DHAVE_ERD)
endif()

if(ENABLE_DKH)
   message(STATUS "DKH in LibMints ENABLED")
   fortran_enabler()
   add_definitions(-DHAVE_DKH)
endif()

# Libint configuration
# Set default for LIBINT_OPT_AM if not set by setup script.
if(NOT LIBINT_OPT_AM)
   set(LIBINT_OPT_AM 5)
endif()

# Psi4-specific includes and libraries
set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/src/lib
    ${PROJECT_BINARY_DIR}/src/lib
)

#
# The location of compiled libraries and executables
#
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

set_property(GLOBAL PROPERTY PSILIB)

# PCMSolver
if(ENABLE_PCMSOLVER)
   find_package(ZLIB)
    if (NOT ZLIB_FOUND)
        message(FATAL_ERROR "No Zlib, no PCMSolver. Skip with -DENABLE_PCMSOLVER=OFF")
        # TODO ability to build psi4 against pre-built pcmsolver library like chemps2
        #message(FATAL_ERROR "No Zlib, no PCMSolver. Build against existing with -DPCMSOLVER_ROOT=/path/to/pcmsolver or skip with -DENABLE_PCMSOLVER=OFF")
   else()
      fortran_enabler()
      add_definitions(-DHAVE_PCMSOLVER)
      message(STATUS "Polarizable Continuum Model via PCMSolver ENABLED")
      link_directories(${EXTERNAL_PROJECT_INSTALL_PREFIX}/lib
                       ${EXTERNAL_PROJECT_INSTALL_PREFIX})
   endif()
   set(PCMSOLVER_PARSE_DIR ${EXTERNAL_PROJECT_INSTALL_PREFIX}/bin)
endif()

#If we have MPI we may want to also build JKFactory which makes J and K's
#in distributed parallel
set(BUILD_JK_FACTORY FALSE)
if(MPI_FOUND AND ENABLE_JKFACTORY)
   set(BUILD_JK_FACTORY TRUE)
endif()
if(BUILD_JK_FACTORY)
      fortran_enabler()
   set(JK_BLAS_LIB "")
   set(JK_BLAS_INC "")
   if(EXPLICIT_BLAS_LIB)
     set(JK_BLAS_LIB ${EXPLICIT_BLAS_LIB})
     set(JK_BLAS_INC ${CMAKE_CXX_FLAGS})
   endif()
   message(STATUS "LibJK BLAS Paths: ${JK_BLAS_INC} ${JK_BLAS_LIB}")
   set(HAVE_GLOBAL_ARRAYS FALSE)
   add_definitions(-DHAVE_JK_FACTORY)
   set(JKROOT ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/libJKFactory)
endif()

# Add the documentation subdirectory
add_subdirectory(doc)

# Recursively add interface directories (some containing dependencies of src)
add_subdirectory(interfaces)

# Recursively add source directories
add_subdirectory(src)

# Add the library directory, for install purposes
add_subdirectory(lib)

# Handle creation of Makefile for plugins
get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
get_property(defs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY COMPILE_DEFINITIONS)
foreach(dir ${dirs})
    set(PLUGIN_INCLUDE_DIRECTORIES "-I${dir} ${PLUGIN_INCLUDE_DIRECTORIES}")
endforeach()
foreach(def ${defs})
    set(PLUGIN_DEFINES "-D${def} ${PLUGIN_DEFINES}")
endforeach()
set(CXX_FLAGS_PLUGIN "")
set(PLUGIN_LDFLAGS "${CMAKE_CXX_LINK_FLAGS} ${LIBC_INTERJECT}")
include(ConfigPlugins) # This module has to be included **after** ConfigCompilerFlags.cmake
string(STRIP ${CXX_FLAGS_PLUGIN} CXX_FLAGS_PLUGIN)
string(STRIP ${PLUGIN_INCLUDE_DIRECTORIES} PLUGIN_INCLUDE_DIRECTORIES)
string(STRIP ${PLUGIN_DEFINES} PLUGIN_DEFINES)
string(STRIP ${PLUGIN_LDFLAGS} PLUGIN_LDFLAGS)
configure_file(include/psiconfig.h.cmake.in include/psiconfig.h)

# Make known that the setup command given and the corresponding CMake
# line are available in the file setup_command in the build directory
message(STATUS "Use the commands in setup_command to reproduce this build")

#If we are making Boost add it as a dependency
if(BUILD_CUSTOM_BOOST)
   add_dependencies(psi4 custom_boost)
endif()

#FILE(MAKE_DIRECTORY ${CMAKE_INSTALL_PREFIX}/bin)
INSTALL(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/bin/psi4 DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

# Install samples directory
INSTALL(
  DIRECTORY "samples"

=== boost/CMakeLists.txt ===
# Based on Ryan M. Richard work in PSI4
# First of all get BOOSTVER underscore separated
string(REGEX REPLACE "\\." "_" BOOSTVER ${BOOSTVER})
set(BOOST_BUILD_DIR ${CMAKE_BINARY_DIR}/boost/boost_${BOOSTVER})
# Transform the ;-separated list to a ,-separated list (digested by the Boost build toolchain!)
string(REPLACE ";" "," b2_needed_components "${needed_components}")

# Prepare stuff to be written to user-config.jam and project-config.jam
# We are going to build only what is necessary. We need to create a custom user-config.jam file
# To get boost to compile MPI we need to append "using mpi ;" to the end of the
# user-config.jam file. MPI_SENT will be the command we append
set(MPI_SENT "")
if(ENABLE_MPI)
   set(MPI_SENT "using mpi ;")
endif()
if(ENABLE_UNIT_TESTS OR ENABLE_PCMSOLVER)
   # Replace unit_test_framework (used by CMake's find_package) with test (understood by Boost build toolchain)
   string(REPLACE "unit_test_framework" "test" b2_needed_components "${b2_needed_components}")
endif()
# For a prettier printout...
string(REPLACE ";" ", " printout "${needed_components}")
message(STATUS "  Libraries to be built: ${printout}")

# Select toolset according to compilers specified by the user
set(toolset   "")
if(CMAKE_CXX_COMPILER_ID MATCHES Intel)
	set(toolset "intel-linux")
elseif(CMAKE_CXX_COMPILER_ID MATCHES Clang)
  set(toolset "clang")
else()
  if(CMAKE_SYSTEM_NAME MATCHES Darwin)
     set(toolset "darwin")
  else()
     set(toolset "gcc")
  endif()
endif()
message(STATUS "  Toolset to be used: ${toolset}")

# Prepare options for call to b2
string(TOLOWER ${CMAKE_BUILD_TYPE} type)

# Write the user-config.jam file
file(WRITE ${BOOST_BUILD_DIR}/user-config.jam "${MPI_SENT}")  

# Unpack Boost and copy boostcpp.jam
add_custom_command(
    OUTPUT boost.unpacked 
    COMMAND ${CMAKE_COMMAND} -E tar xjf ${CMAKE_SOURCE_DIR}/boost/boost_${BOOSTVER}.tar.bz2 
    # Copy custom boostcpp.jam (to get versioned format as I want it!)
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/boost/boostcpp.jam ${BOOST_BUILD_DIR}
    COMMAND touch boost.unpacked
    DEPENDS ${CMAKE_SOURCE_DIR}/boost/boost_${BOOSTVER}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/boost
    COMMENT "Unpacking Boost")

# Run bootstrap.sh to configure the build. We will install in ${PROJECT_BINARY_DIR}/boost
add_custom_command(
    OUTPUT boost.configured
    COMMAND ./bootstrap.sh --with-toolset=${toolset}
            --with-libraries="${b2_needed_components}"
	    --with-python=${PYTHON_EXECUTABLE}
	    --prefix=${CUSTOM_BOOST_LOCATION} 1> boost.configured.log 2> boost.configured.err
    COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_BINARY_DIR}/boost/boost.configured	    
    WORKING_DIRECTORY ${BOOST_BUILD_DIR}
    DEPENDS boost.unpacked
    COMMENT "Configuring Boost")

# Build Boost
add_custom_command(
    OUTPUT boost.built
    COMMAND ./b2 toolset=${toolset} variant=${type} link=static cxxflags=-fPIC
    threading=multi --user-config=user-config.jam 1> boost.built.log 2> boost.built.err
    COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_BINARY_DIR}/boost/boost.built
    WORKING_DIRECTORY ${BOOST_BUILD_DIR}
    DEPENDS boost.configured 
    COMMENT "Building Boost")

# Install Boost
add_custom_command(
    OUTPUT boost.installed
    COMMAND ./b2 install toolset=${toolset} variant=${type} link=static
    threading=multi --user-config=user-config.jam 1> boost.installed.log 2> boost.installed.err
    COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_BINARY_DIR}/boost/boost.installed
    WORKING_DIRECTORY ${BOOST_BUILD_DIR}
    DEPENDS boost.built 
    COMMENT "Installing Boost")

# Clean-up
add_custom_command(
    OUTPUT boost.cleanedup
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${BOOST_BUILD_DIR}
    COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_BINARY_DIR}/boost/boost.cleanedup
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/boost
    DEPENDS boost.installed 
    COMMENT "Clean-up Boost")

add_custom_target(custom_boost DEPENDS boost.cleanedup)

=== doc/CMakeLists.txt ===
add_subdirectory(doxygen)
add_subdirectory(sphinxman)
add_subdirectory(cloc)

=== interfaces/CMakeLists.txt ===
set_property(GLOBAL PROPERTY INTERFACES)
###### START internally stored, psi4-dependency projects ########

# <<<  libefp  >>>

add_subdirectory(libefp)

###### END internally stored, psi4-dependency projects ##########

###### START externally stored, no-dependency projects ##########

# <<<  dummyplugin  >>>

if(${USEEXT_DUMMY_PLUGIN})
    add_subdirectory(dummyplugin)
endif()

# <<<  CheMPS2  >>>
# handled by ConfigChemps2

###### END externally stored, no-dependency projects ############

=== lib/CMakeLists.txt ===
set(Folders2Copy "basis" "databases" "grids" "plugin" "python" "quadratures" "efpfrag" "scripts")
INSTALL(
  DIRECTORY ${Folders2Copy} 
  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/psi
  USE_SOURCE_PERMISSIONS
  PATTERN ".pyc" EXCLUDE
)

=== plugins/CMakeLists.txt ===
add_subdirectory(aointegrals)
add_subdirectory(backtrans)
add_subdirectory(mointegrals)
add_subdirectory(mollerplesset2)
add_subdirectory(sointegrals)
add_subdirectory(skeleton)

=== tests/CMakeLists.txt ===
#These tests aren't set-up the same way as the others
set(TestsNotSetUpRight cfour optking testgrendel)

# In order to get CTest to run tests in separate categories,
# labels are used. All tests must carry the label "psi".
#
# The following labels are defined:
#
#  longtests   = The (as of right now) 4 really long tests
#  longertests = Every test in the test folder less longtests
#  quicktests  = Proper subset of tests deemed to run quickly
#
# It is possible to specify more than one label per test. CMake
# expects a ;-separated list, e.g. "psi;quicktests;scf"
# It is mandatory that any test carries a length label!
# It is suggested to add at least a second label to specify the method tested.
#
#  We use ctest -I [start,end] where start is the test number we start with
#  and end is the test number we end with.  We will then use math to back out
#  the appropriate starts and ends...
#
#
#  In order to ensure that this works properly, please add your tests to the
#  appropriate variables given below

add_subdirectory(adc1)
add_subdirectory(adc2)
add_subdirectory(casscf-fzc-sp)
add_subdirectory(casscf-sa-sp)
add_subdirectory(casscf-sp)
add_subdirectory(castup1)
add_subdirectory(castup2)
add_subdirectory(castup3)
add_subdirectory(cc1)
add_subdirectory(cc10)
add_subdirectory(cc11)
add_subdirectory(cc12)
add_subdirectory(cc13)
add_subdirectory(cc13a)
add_subdirectory(cc14)
add_subdirectory(cc15)
add_subdirectory(cc16)
add_subdirectory(cc17)
add_subdirectory(cc18)
add_subdirectory(cc19)
add_subdirectory(cc2)
add_subdirectory(cc21)
add_subdirectory(cc22)
add_subdirectory(cc23)
add_subdirectory(cc24)
add_subdirectory(cc25)
add_subdirectory(cc26)
add_subdirectory(cc27)
add_subdirectory(cc28)
add_subdirectory(cc29)
add_subdirectory(cc3)
add_subdirectory(cc30)
add_subdirectory(cc31)
add_subdirectory(cc32)
add_subdirectory(cc33)
add_subdirectory(cc34)
add_subdirectory(cc35)
add_subdirectory(cc36)
add_subdirectory(cc37)
add_subdirectory(cc38)
add_subdirectory(cc39)
add_subdirectory(cc4)
add_subdirectory(cc40)
add_subdirectory(cc41)
add_subdirectory(cc42)
add_subdirectory(cc43)
add_subdirectory(cc44)
add_subdirectory(cc45)
add_subdirectory(cc46)
add_subdirectory(cc47)
add_subdirectory(cc48)
add_subdirectory(cc49)
add_subdirectory(cc4a)
#add_subdirectory(cc5)
add_subdirectory(cc50)
add_subdirectory(cc51)
add_subdirectory(cc52)
add_subdirectory(cc53)
add_subdirectory(cc54)
add_subdirectory(cc55)
add_subdirectory(cc5a)
add_subdirectory(cc6)
add_subdirectory(cc8)
add_subdirectory(cc8a)
add_subdirectory(cc8b)
add_subdirectory(cc8c)
add_subdirectory(cc9)
add_subdirectory(cc9a)
add_subdirectory(cdomp2-1)
add_subdirectory(cdomp2-2)
add_subdirectory(cepa0-grad1)
add_subdirectory(cepa0-grad2)
add_subdirectory(cepa1)
add_subdirectory(cepa2)
add_subdirectory(cepa3)
add_subdirectory(ci-multi)
add_subdirectory(cisd-h2o+-0)
add_subdirectory(cisd-h2o+-1)
add_subdirectory(cisd-h2o+-2)
add_subdirectory(cisd-h2o-clpse)
add_subdirectory(cisd-opt-fd)
add_subdirectory(cisd-sp)
add_subdirectory(cisd-sp-2)
add_subdirectory(cubeprop)
add_subdirectory(dcft-grad1)
add_subdirectory(dcft-grad2)
add_subdirectory(dcft1)
add_subdirectory(dcft2)
add_subdirectory(dcft3)
add_subdirectory(dcft4)
add_subdirectory(dcft5)
add_subdirectory(dcft6)
add_subdirectory(dcft7)
add_subdirectory(dcft8)
add_subdirectory(dcft9)
add_subdirectory(dfccd1)
add_subdirectory(dfccdl1)
add_subdirectory(dfccd-grad1)
add_subdirectory(dfccsd1)
add_subdirectory(dfccsdl1)
add_subdirectory(dfccsd-grad1)
add_subdirectory(dfmp2-1)
add_subdirectory(dfmp2-2)
add_subdirectory(dfmp2-3)
add_subdirectory(dfmp2-4)
add_subdirectory(dfmp2-grad1)
add_subdirectory(dfmp2-grad2)
add_subdirectory(dfmp2-grad3)
add_subdirectory(dfmp2-grad4)
add_subdirectory(dfomp2-1)
add_subdirectory(dfomp2-2)
add_subdirectory(dfomp2-3)
add_subdirectory(dfomp2-4)
add_subdirectory(dfomp2-grad1)
add_subdirectory(dfomp2-grad2)
add_subdirectory(dfscf-bz2)
add_subdirectory(dft-b2plyp)
add_subdirectory(dft-dldf)
add_subdirectory(dft-freq)
add_subdirectory(dft-grad)
add_subdirectory(dft-pbe0-2)
add_subdirectory(dft-psivar)
add_subdirectory(dft1)
add_subdirectory(dft1-alt)
add_subdirectory(dft2)
add_subdirectory(dft3)
add_subdirectory(docs-bases)
add_subdirectory(docs-dft)
add_subdirectory(docs-psimod)
add_subdirectory(fci-dipole)
add_subdirectory(fci-h2o)
add_subdirectory(fci-h2o-2)
add_subdirectory(fci-h2o-fzcv)
add_subdirectory(fci-tdm)
add_subdirectory(fci-tdm-2)
add_subdirectory(fd-freq-energy)
add_subdirectory(fd-freq-energy-large)
add_subdirectory(fd-freq-gradient)
add_subdirectory(fd-freq-gradient-large)
add_subdirectory(fd-gradient)
add_subdirectory(fnocc1)
add_subdirectory(fnocc2)
add_subdirectory(fnocc3)
add_subdirectory(fnocc4)
add_subdirectory(frac)
add_subdirectory(ghosts)
add_subdirectory(gibbs)
#add_subdirectory(large_atoms)
add_subdirectory(matrix1)
add_subdirectory(mcscf1)
add_subdirectory(mcscf2)
add_subdirectory(mcscf3)
add_subdirectory(min_input)
add_subdirectory(mints1)
add_subdirectory(mints2)
add_subdirectory(mints3)
add_subdirectory(mints4)
add_subdirectory(mints5)
add_subdirectory(mints6)
add_subdirectory(mints8)
add_subdirectory(mints9)
add_subdirectory(mom)
add_subdirectory(mp2-1)
add_subdirectory(mp2-def2)
add_subdirectory(mp2-grad1)
add_subdirectory(mp2-grad2)
add_subdirectory(mp2_5-grad1)
add_subdirectory(mp2_5-grad2)
add_subdirectory(mp3-grad1)
add_subdirectory(mp3-grad2)
add_subdirectory(mpn-bh)
add_subdirectory(ocepa-freq1)
add_subdirectory(ocepa-grad1)
add_subdirectory(ocepa-grad2)
add_subdirectory(ocepa1)
add_subdirectory(ocepa2)
add_subdirectory(ocepa3)
add_subdirectory(omp2-1)
add_subdirectory(omp2-2)
add_subdirectory(omp2-3)
add_subdirectory(omp2-4)
add_subdirectory(omp2-5)
add_subdirectory(omp2-grad1)
add_subdirectory(omp2-grad2)
add_subdirectory(omp2_5-1)
add_subdirectory(omp2_5-2)
add_subdirectory(omp2_5-grad1)
add_subdirectory(omp2_5-grad2)
add_subdirectory(omp3-1)
add_subdirectory(omp3-2)
add_subdirectory(omp3-3)
add_subdirectory(omp3-4)
add_subdirectory(omp3-5)
add_subdirectory(omp3-grad1)
add_subdirectory(omp3-grad2)
add_subdirectory(opt-lindep-change)
add_subdirectory(opt1)
add_subdirectory(opt1-fd)
add_subdirectory(opt2)
add_subdirectory(opt2-fd)
add_subdirectory(opt3)
add_subdirectory(opt4)
add_subdirectory(opt5)
add_subdirectory(opt6)
add_subdirectory(opt7)
add_subdirectory(props1)
add_subdirectory(props2)
add_subdirectory(props3)
add_subdirectory(psimrcc-ccsd_t-1)
add_subdirectory(psimrcc-ccsd_t-2)
add_subdirectory(psimrcc-ccsd_t-3)
add_subdirectory(psimrcc-ccsd_t-4)
add_subdirectory(psimrcc-fd-freq1)
add_subdirectory(psimrcc-fd-freq2)
add_subdirectory(psimrcc-pt2)
add_subdirectory(psimrcc-sp1)
add_subdirectory(psithon1)
add_subdirectory(psithon2)
add_subdirectory(pubchem1)
add_subdirectory(pubchem2)
add_subdirectory(pywrap-alias)
add_subdirectory(pywrap-all)
add_subdirectory(pywrap-basis)
add_subdirectory(pywrap-cbs1)
add_subdirectory(pywrap-checkrun-convcrit)
add_subdirectory(pywrap-checkrun-rhf)
add_subdirectory(pywrap-checkrun-rohf)
add_subdirectory(pywrap-checkrun-uhf)
add_subdirectory(pywrap-db1)
add_subdirectory(pywrap-db2)
add_subdirectory(pywrap-db3)
add_subdirectory(pywrap-freq-e-sowreap)
add_subdirectory(pywrap-molecule)
add_subdirectory(pywrap-opt-sowreap)
add_subdirectory(rasci-c2-active)
add_subdirectory(rasci-h2o)
add_subdirectory(rasci-ne)
add_subdirectory(rasscf-sp)
add_subdirectory(sad1)
add_subdirectory(sapt1)
add_subdirectory(sapt2)
add_subdirectory(sapt3)
add_subdirectory(sapt4)
add_subdirectory(sapt5)
add_subdirectory(scf-bz2)
add_subdirectory(scf-guess-read)
add_subdirectory(scf-bs)
add_subdirectory(scf1)
add_subdirectory(scf11-freq-from-energies)
add_subdirectory(scf2)
add_subdirectory(scf3)
add_subdirectory(scf4)
add_subdirectory(scf5)
add_subdirectory(scf6)
add_subdirectory(soscf1)
add_subdirectory(stability1)
add_subdirectory(tu1-h2o-energy)
add_subdirectory(tu2-ch2-energy)
add_subdirectory(tu3-h2o-opt)
add_subdirectory(tu4-h2o-freq)
add_subdirectory(tu5-sapt)
add_subdirectory(tu6-cp-ne2)
add_subdirectory(x2c1)
add_subdirectory(x2c2)
add_subdirectory(x2c3)
add_subdirectory(zaptn-nh2)

###### START internal-executable-dependent tests ################

# For code that is distributed with and required for psi4 to build,
#   and thus should always be tested, but is developed and maintained
#   externally and dropped into psi4 as version increment, and thus
#   should get its own subdirectory:
#   * Follow directory structure described below for ext-exe-dep
#   * Follow un-qualified inclusion as above for normal tests

add_subdirectory(libefp)

###### END internal-executable-dependent tests ##################

###### START external-executable-dependent tests ################

# Set up groups of test cases analogous to dftd3 below
#   In particular, new ext-exe-dep tests should
#   * get their own directory in tests (e.g., tests/dftd3)
#   * have a name that doesn't repeat the exe (e.g., tests/dftd3/energy)
#   * be listed in the exeShort and exeLong variable name as exe-name (e.g., dftd3-energy)
#   * be sure the exe is listed in the python code below (search 'partition')

# <<<  DFTD3  >>>

find_program(DFTD3_EXECUTABLE
             NAMES dftd3
             DOC "Path to Grimme's dftd3 executable")

if(DFTD3_EXECUTABLE)
   add_subdirectory(dftd3)
   message(STATUS "dftd3 executable for interfaced DFTD3 found. Test cases added.")
endif()

# <<<  MRCC  >>>

find_program(MRCC_EXECUTABLE
             NAMES dmrcc
             DOC "Path to Kallay's mrcc executable")

if(MRCC_EXECUTABLE)
   add_subdirectory(mrcc)
   message(STATUS "dmrcc executable for interfaced MRCC found. Test cases added.")
endif()

# <<<  CFOUR  >>>

find_program(CFOUR_EXECUTABLE
             NAMES xcfour
             DOC "Path to Stanton and Gauss's xcfour executable")

if(CFOUR_EXECUTABLE)
   add_subdirectory(cfour)
   message(STATUS "xcfour executable for interfaced CFOUR found. Test cases added.")
endif()

###### END external-executable-dependent tests ##################

# External module dependent tests
if(ENABLE_PCMSOLVER)
   add_subdirectory(pcm_scf)
   add_subdirectory(pcm_dft)
endif()

if(NOT PERL_FOUND)
   message(WARNING "Perl was not found. Some Coupled Cluster test cases will not be thoroughly checked.")
endif()

if(ENABLE_CHEMPS2)
    add_subdirectory(dmrg)
endif()

=== doc/cloc/CMakeLists.txt ===
# Setup use of cloc perl script for counting lines of code
if(PERL_FOUND)
   add_custom_target(
       count_lines
       COMMAND "${PYTHON_EXECUTABLE}" "${PROJECT_BINARY_DIR}/bin/counter.py")
   add_custom_target(
       bar_charts 
       COMMAND "${PYTHON_EXECUTABLE}" "${PROJECT_BINARY_DIR}/bin/create_bar_charts.py")
   add_dependencies(bar_charts count_lines)
else()
   message(STATUS "Perl missing. You won't be able to create cloc stats.")
endif()

=== doc/doxygen/CMakeLists.txt ===
# Setup Doxygen documentation
if(DOXYGEN_FOUND)
   # Configuration of the Doxygen configuration file
   #set(PSI_VERSION "${PSI_VERSION}") # this is already defined
   set(top_scrdir ${CMAKE_SOURCE_DIR})
   set(HAVE_QHELP "NO")
   set(QHELP_GENERATOR "")
   set(HAVE_DOT "NO")
   set(DOT_PATH "")
   set(DOXY_OUT_DIR ${PROJECT_BINARY_DIR}/doc/doxygen)
   set(DOXY_OUT_FILE ${DOXY_OUT_DIR}/doxygen.cfg)
   configure_file(
       ${PROJECT_SOURCE_DIR}/doc/doxygen/doxygen.cfg.in
       ${DOXY_OUT_FILE})

 
   add_custom_target(doc ${DOXYGEN_EXECUTABLE}
                         ${DOXY_OUT_FILE}
                         WORKING_DIRECTORY ${DOXY_OUT_DIR}
                         COMMENT "Generating Doxygen code for Psi 4" VERBATIM
                    )
endif(DOXYGEN_FOUND)

=== doc/sphinxman/CMakeLists.txt ===
# Setup and build Sphinx documentation
if(PERL_FOUND AND SPHINX_FOUND)
    set(CCSD "${CMAKE_CURRENT_SOURCE_DIR}")
    set(CCBD "${CMAKE_CURRENT_BINARY_DIR}")


    # Configure Sphinx build
    configure_file(
        "${CCSD}/source/conf.py.in"
        "${CCBD}/source/conf.py"
        @ONLY)


    # Static-doc reST files
    set(STATICDOC abbr_accents.rst adc.rst appendices.rst basissets.rst basissets_byelement.rst bestpractices_py.rst bibliography.rst cbs.rst cbs_eqn.rst contributing.rst cp.rst customizing.rst db.rst detci.rst dfmp2.rst diatomic.rst documentation.rst energy.rst external.rst freq.rst glossary_psivariables.rst index.rst intercalls.rst interfacing.rst introduction.rst methods.rst notes_c.rst notes_py.rst oeprop.rst opt.rst optking.rst plugins.rst programming.rst prop.rst psithonfunc.rst psithoninput.rst quickaddalias.rst basissets_tables.rst quickadddatabase.rst sapt.rst sowreap.rst testsuite.rst tutorial.rst dft_byfunctional.rst scf.rst mrcc.rst psimrcc.rst cc.rst dft.rst fnocc.rst installfile.rst optionshandling.rst basissets_byfamily.rst psipep.rst pep0001.rst dftd3.rst occ.rst molden.rst cubeprop.rst dcft.rst dkh.rst proc_py.rst psithonmol.rst cfour.rst mrcc_table_energy.rst cfour_table_energy.rst cfour_table_grad.rst prog_basissets.rst libefp.rst conda.rst)
    # * compute relative path btwn top_srcdir and objdir/doc/sphinxman
    execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
        "import sys; import os; print('/' + os.path.relpath('${CMAKE_SOURCE_DIR}', '${CCBD}') + '/../')"
        OUTPUT_VARIABLE SFNX_INCLUDE OUTPUT_STRIP_TRAILING_WHITESPACE)
    # * copy all over to objdir, substituting literalinclude along the way
    foreach(rst ${STATICDOC})
       configure_file(
        ${CCSD}/source/${rst}
        ${CCBD}/source/${rst}
        @ONLY)
    endforeach(rst)
    # * duplicate index.rst as contents.rst for toc link
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CCBD}/source/index.rst ${CCBD}/source/contents.rst)
    # * copy fake psi4.py over to objdir
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CCSD}/source/psi4.py ${CCBD}/source)
    # * copy logo image file (configure_file corrupts file)
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CCSD}/source/psi4banner.png ${CCBD}/source)

    # * copy favicon image file (configure_file corrupts file)
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CCSD}/source/favicon-psi4.ico ${CCBD}/source)


    # Autodoc basis sets
    add_custom_command(
        COMMAND ${PERL_EXECUTABLE} ${CCSD}/document_bases.pl ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_psi4bases.rst
        DEPENDS ${CCSD}/document_bases.pl
                ${CMAKE_SOURCE_DIR}/lib/basis/*.gbs
        COMMENT "Autodoc basis sets")


    # Autodoc binary scratch files
    add_custom_command(
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/document_psifiles.py ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_psifiles.rst
        DEPENDS ${CCSD}/document_psifiles.py
                ${CMAKE_SOURCE_DIR}/include/psifiles.h
        COMMENT "Autodoc binary scratch files")

    # Autodoc physical constants
    add_custom_command(
        COMMAND ${PERL_EXECUTABLE} ${CCSD}/document_physconst.pl ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_physconst.rst
        DEPENDS ${CCSD}/document_physconst.pl
                ${CMAKE_SOURCE_DIR}/include/physconst.h
        COMMENT "Autodoc physical constants")


    # Autodoc options c-side
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E make_directory source/autodir_options_c
        COMMAND ${PERL_EXECUTABLE} ${CCSD}/document_options_c.pl ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_abbr_options_c.rst
                ${CCBD}/source/autodoc_glossary_options_c.rst
                ${CCBD}/source/autodoc_options_c_bymodule.rst
                ${CCBD}/source/autodir_options_c/module__scf.rst  # representative
                ${CCBD}/source/autodir_options_c/scf__scf_type.rst  # representative
        DEPENDS ${CCSD}/document_options_c.pl
                ${CMAKE_SOURCE_DIR}/src/bin/psi4/read_options.cc
        COMMENT "Autodoc options c-side")


    # Autodoc PSI variables c-side
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E make_directory source/autodir_psivariables
        COMMAND ${PERL_EXECUTABLE} ${CCSD}/document_psivariables.pl ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_psivariables_bymodule.rst
                ${CCBD}/source/autodir_psivariables/module__scf.rst  # representative
        DEPENDS ${CCSD}/document_psivariables.pl
                ${CMAKE_SOURCE_DIR}/src/*/*/*.cc
        COMMENT "Autodoc PSI variables c-side")


    # Autodoc Cfour PSI variables
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E make_directory source/autodir_psivariables
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/document_cfour.py ${CCSD}
        OUTPUT  ${CCBD}/source/autodir_psivariables/module__cfour.rst
        DEPENDS ${CCSD}/document_cfour.py
                ${CMAKE_SOURCE_DIR}/lib/python/qcdb/cfour.py
                ${CCBD}/source/autodoc_psivariables_bymodule.rst
        COMMENT "Autodoc Cfour PSI variables")


    # Autodoc databases
    add_custom_command(
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/document_databases.py ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_available_databases.rst
        DEPENDS ${CCSD}/document_databases.py
                ${CMAKE_SOURCE_DIR}/lib/databases/*.py
        COMMENT "Autodoc databases")


    # Autodoc test cases
    add_custom_command(
        COMMAND ${PERL_EXECUTABLE} ${CCSD}/document_tests.pl ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_testsuite_corepsi4.rst
                ${CCBD}/source/autodoc_testsuite_dftd3.rst
        DEPENDS ${CCSD}/document_tests.pl
                ${CMAKE_SOURCE_DIR}/tests/*/input.dat
                ${CMAKE_SOURCE_DIR}/tests/*/*/input.dat
        COMMENT "Autodoc test cases")


    # Autodoc driver
    add_custom_command(
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/document_driver.py ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_driver.rst
        DEPENDS ${CMAKE_SOURCE_DIR}/lib/python/*.py
                ${CCSD}/document_driver.py
        COMMENT "Autodoc driver")


    # Autodoc psi4 module
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ctest -R docs-psimod
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-psimod/autodoc_psimod.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-psimod/autodoc_man_psi4.txt ${CCBD}/source
        OUTPUT  ${CCBD}/source/autodoc_psimod.rst
                ${CCBD}/source/autodoc_man_psi4.txt
        DEPENDS ${CMAKE_SOURCE_DIR}/src/*/*/*.cc
                ${CMAKE_SOURCE_DIR}/tests/docs-psimod/input.dat
                ${CMAKE_BINARY_DIR}/bin/psi4${CMAKE_EXECUTABLE_SUFFIX}
        COMMENT "Autodoc psi4 module")


    # Autodoc functionals
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ctest -R docs-dft
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_energy.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_opt.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_all.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_gga.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_meta.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_lrc.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_hybrid.rst ${CCBD}/source
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_dhybrid.rst ${CCBD}/source
        #COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_scsdhybrid.rst ${CCBD}/source  # commented until populated again to appease Sphinx
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-dft/autodoc_dft_disp.rst ${CCBD}/source
        OUTPUT  ${CCBD}/source/autodoc_dft_energy.rst
                ${CCBD}/source/autodoc_dft_opt.rst
                ${CCBD}/source/autodoc_dft_all.rst
                ${CCBD}/source/autodoc_dft_gga.rst
                ${CCBD}/source/autodoc_dft_meta.rst
                ${CCBD}/source/autodoc_dft_lrc.rst
                ${CCBD}/source/autodoc_dft_hybrid.rst
                ${CCBD}/source/autodoc_dft_dhybrid.rst
                #${CCBD}/source/autodoc_dft_scsdhybrid.rst  # commented until populated again to appease Sphinx
                ${CCBD}/source/autodoc_dft_disp.rst
        DEPENDS ${CMAKE_SOURCE_DIR}/lib/python/functional.py
                ${CMAKE_SOURCE_DIR}/tests/docs-dft/input.dat
                ${CMAKE_BINARY_DIR}/bin/psi4${CMAKE_EXECUTABLE_SUFFIX}
        COMMENT "Autodoc functionals")


    # Autodoc auxiliary basis sets
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ctest -R docs-bases
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/tests/docs-bases/autodoc_basissets_byfamily.rst ${CCBD}/source
        OUTPUT ${CCBD}/source/autodoc_basissets_byfamily.rst
        DEPENDS ${CMAKE_SOURCE_DIR}/lib/python/p4util/basislist.py
                ${CMAKE_SOURCE_DIR}/lib/python/p4util/basislistdunning.py
                ${CMAKE_SOURCE_DIR}/lib/python/p4util/basislistother.py
                ${CMAKE_SOURCE_DIR}/tests/docs-bases/input.dat
                ${CMAKE_BINARY_DIR}/bin/psi4${CMAKE_EXECUTABLE_SUFFIX}
        COMMENT "Autodoc auxiliary basis sets")


    # Autodoc plugins
    #   Not at all in working order
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E make_directory source/autodir_plugins
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/document_plugins.py ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_abbr_options_plugins.rst
                ${CCBD}/source/autodoc_available_plugins.rst
                ${CCBD}/source/autodir_plugins/glossary__aointegrals.rst
                ${CCBD}/source/autodir_plugins/module__aointegrals.rst
                ${CCBD}/source/autodir_plugins/aointegrals__print.rst
        DEPENDS ${CCSD}/document_plugins.py
                ${CMAKE_SOURCE_DIR}/plugins/*/*.py
                ${CMAKE_SOURCE_DIR}/plugins/*/doc.rst
        COMMENT "Autodoc plugins")


    # Autodoc efp fragments
    add_custom_command(
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/document_efpfrag.py ${CCSD}
        OUTPUT  ${CCBD}/source/autodoc_available_efpfrag.rst
        DEPENDS ${CCSD}/document_efpfrag.py
                ${CMAKE_SOURCE_DIR}/lib/efpfrag/*.efp
        COMMENT "Autodoc efp fragments")

    # Format git log for feed
    add_custom_command(
        COMMAND ${CMAKE_COMMAND} -E make_directory feed
        COMMAND ${PYTHON_EXECUTABLE} ${CCSD}/extract_changeset.py ${CCBD}
        OUTPUT  ${CCBD}/feed/history_trac_changeset.txt
                ${CCBD}/feed/latest_trac_changeset.txt
        DEPENDS ${CCSD}/extract_changeset.py
        COMMENT "Format git --log for psicode.org feed")

    # Establishing dependencies for docs targets

    # * mini github feed for psicode.org
    add_custom_target(ghfeed
        DEPENDS ${CCBD}/feed/history_trac_changeset.txt
                ${CCBD}/feed/latest_trac_changeset.txt
        COMMENT "Preparing GitHub feed")

    # * announcement
    if (LATEX_COMPILER AND PDFLATEX_COMPILER)
        message("-- Documentation targets available: sphinxman (html), sphinxmini (quick html), sphinxpdf (LaTeX --> PDF)")
    else()
        message("-- Documentation targets available: sphinxman (html), sphinxmini (quick html)")

=== interfaces/dummyplugin/CMakeLists.txt ===
include(ExternalProject)

set(PLUG "dummyplugin")
set(PLUG_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/${PLUG}")

ExternalProject_Add(${PLUG}
    PREFIX ${PLUG_PREFIX}
    GIT_REPOSITORY https://github.com/loriab/dummyplugin.git
    CONFIGURE_COMMAND cat ${PLUG_PREFIX}/src/${PLUG}/Makefile.template | sed -e "s|PLUGIN_CXX|${CMAKE_CXX_COMPILER}|g" -e "s|PLUGIN_DEFINES|${PLUGIN_DEFINES}|g" -e "s|PLUGIN_FLAGS|${CMAKE_CXX_FLAGS}|g" -e "s|PLUGIN_INCLUDES|${PLUGIN_INCLUDE_DIRECTORIES}|g" -e "s|PLUGIN_OBJDIR|${CMAKE_BINARY_DIR}|g" -e "s|PLUGIN_INSTALLDIR|${PLUG_PREFIX}|g" > ${PLUG_PREFIX}/src/${PLUG}/Makefile
    BUILD_IN_SOURCE 1
    BUILD_COMMAND ${MAKE}
)

=== interfaces/gpu_dfcc/CMakeLists.txt ===
include(ExternalProject)

set(PLUG "gpu_dfcc")
set(PLUG_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/${PLUG}")

find_package(CUDA REQUIRED)
if(${CUDA_FOUND})
    message("-- NVCC=${CUDA_NVCC} version ${CUDA_VERSION_STRING} rootdir ${CUDA_TOOLKIT_ROOT_DIR} lib ${CUDA_LIBRARIES}")
else()
    message("nocuda")
endif()
set(MY_CUDAFLAGS "-arch sm_13 -Xcompiler -fopenmp --compiler-options '-fPIC' -O2")
set(MY_CUDALIBS "-lcublas -L/usr/local/cuda/lib64/")
set(MY_NVCC "nvcc")

ExternalProject_Add(gpu_dfcc
    PREFIX ${PLUG_PREFIX}
    GIT_REPOSITORY https://github.com/edeprince3/gpu_dfcc.git
    #CONFIGURE_COMMAND cat ${PLUG_PREFIX}/src/${PLUG}/Makefile.template | sed -e "s|MY_TOP_SRCDIR|${CMAKE_SOURCE_DIR}|g" -e "s|MY_TOP_OBJDIR|${CMAKE_BINARY_DIR}|g" -e "s|MY_NVCC|${CUDA_NVCC}|g" -e "s|MY_CUDAFLAGS|${MY_CUDAFLAGS}|g" -e "s|MY_CUDALIBS|${MY_CUDALIBS}|g" > ${PLUG_PREFIX}/src/${PLUG}/Makefile
    CONFIGURE_COMMAND cat ${PLUG_PREFIX}/src/${PLUG}/Makefile.template | sed -e "s|PLUGIN_CXX|${CMAKE_CXX_COMPILER}|g" -e "s|PLUGIN_DEFINES|${PLUGIN_DEFINES}|g" -e "s|PLUGIN_FLAGS|${CMAKE_CXX_FLAGS}|g" -e "s|PLUGIN_INCLUDES|${PLUGIN_INCLUDE_DIRECTORIES}|g" -e "s|PLUGIN_OBJDIR|${CMAKE_BINARY_DIR}|g" -e "s|PLUGIN_INSTALLDIR|${PLUG_PREFIX}|g" > ${PLUG_PREFIX}/src/${PLUG}/Makefile
    BUILD_IN_SOURCE 1
    BUILD_COMMAND ${MAKE}
)

=== debian/changelog ===
psi4 (1:0.3-5) unstable; urgency=medium

  * Fix FTBFS with perl 5.22, thanks gregor herrmann. (Closes: #810017)
  * Update debian/watch, remove debian/get-orig-source.sh and
    debian/README.source since upstream moved to GitHub.
  * Update debian/copyright: remove one unnecessary item, add two items,
    fix license short names to make Lintian happy.
  * Add debian/clean to fix FTBFSx2.

 -- Graham Inggs <ginggs@debian.org>  Tue, 12 Jan 2016 17:10:34 +0200

psi4 (1:0.3-4) unstable; urgency=medium

  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev,
    thanks Bas Couwenberg. (Closes: #807236)
  * Add myself to uploaders.

 -- Graham Inggs <ginggs@debian.org>  Thu, 17 Dec 2015 09:58:13 +0200

psi4 (1:0.3-3) unstable; urgency=medium

  * debian/rules (override_dh_auto_build): Fix building of manual.
  * debian/patches/system_libint.patch: New patch, skips building of the
    internal libint and uses the system-provided one.
  * debian/control (Build-Depends): Added libint-dev.
  * debian/rules (override_dh_auto_configure): Add -DEXPLICIT_LIBS option.
  * debian/rules (override_dh_auto_install): Create example directory at start
    and install example data under debian/tmp.
  * debian/rules (override_dh_auto_install): Fix installation of HTML
    documentation.
  * debian/psi4.install: Install example psi4rc. 
  * debian/psi4-data.install: Install HTML documentation and example inputs.
  * debian/psi4-data.links: Removed.

 -- Michael Banck <mbanck@debian.org>  Thu, 01 Oct 2015 10:57:40 +0200

psi4 (1:0.3-2) unstable; urgency=medium

  * debian/patches/gcc5_compile_error.patch: New patch, fixes compile errors
    with g++-5 on various architectures, taken from upstream commit de1fc3ed.
  * debian/rules (override_dh_auto_install-arch,
  * override_dh_auto_install-indep): Combine both into override_dh_auto_install
    again, to fix Arch:all building.
  * debian/rules (override_dh_auto_install): Remove all byte-compiled python
    files from python data directory.

 -- Michael Banck <mbanck@debian.org>  Wed, 23 Sep 2015 12:12:19 +0200

psi4 (1:0.3-1) unstable; urgency=medium

  * New upstream prerelease.
  * debian/patches/git_version_fix.patch: New patch, fixes a build failure for
    release tarballs if GIT_VERSION is not defined, taken from upstream commit
    1b91513b.
  * debian/control (Build-Depends): Replaced autotools-dev with cmake.
  * debian/control (Build-Depends): Added libboost-chrono-dev and
    libboost-timer-dev.
  * debian/rules (override_dh_auto_configure): Remove autoconf-specific
    options, and add CMAKE_BUILD_TYPE=RelWithDebInfo define.
  * debian/rules (PSI_SCRATCH, SCRATCH): Removed.
  * debian/rules (override_dh_auto_clean): Update accordingly.
  * debian/rules (override_dh_auto_test): Create scratch directory and run
    `ctest -L quicktests' as testsuite.
  * debian/rules (OMPI_MCA_orte_rsh_agent): New variable.
  * debian/rules (override_dh_auto_install-indep): Remove samples from data
    directory.
  * debian/control (Build-Depends): Added libchemps2-dev.
  * debian/rules: Remove autotools_dev option from dh.
  * debian/rules (override_dh_auto_configure): Add -DENABLE_CHEMPS2 and
    -DCHEMPS2_ROOT options.
  * debian/control (Build-Depends): Added libhdf5-dev and libgsl0-dev.
  * debian/control (Description): Add DMRG.
  * debian/rules (override_dh_auto_test): Also run DMRG tests.
  * debian/upstream: Move to ...
  * debian/upstream/metadata: ... here.
  * debian/control (Standards-Version): Bumped to 3.9.6.

 -- Michael Banck <mbanck@debian.org>  Tue, 22 Sep 2015 19:00:36 +0200

psi4 (4.0~beta5+dfsg-2) unstable; urgency=low

  * debian/rules (DEB_BUILD_MULTIARCH): New variable, populated from
    dpkg-architecture.
  * debian/rules (override_dh_auto_configure): Added --with-boost-libdir.
  * debian/rules (override_dh_auto_install): Split up into
    override_dh_auto_install-arch and override_dh_auto_install-indep (Closes:
    #732044).
  * debian/README.source: New file.

 -- Michael Banck <mbanck@debian.org>  Sat, 14 Dec 2013 20:00:46 +0100

psi4 (4.0~beta5+dfsg-1) unstable; urgency=low

  * Initial Upload of psi4, based on psi3 packaging.

 -- Michael Banck <mbanck@debian.org>  Sun, 03 Nov 2013 17:43:51 +0100

=== debian/control ===
Source: psi4
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Graham Inggs <ginggs@debian.org>
Build-Depends: cmake,
               debhelper (>> 8),
	       dvipng,
	       gfortran,
               libblas-dev,
	       libboost-chrono-dev,
	       libboost-filesystem-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-timer-dev,
	       libchemps2-dev,
	       libgsl-dev,
	       libhdf5-dev,
	       libint-dev,
               liblapack-dev,
	       python-dev,
               python-numpy,
	       python-sphinx,
	       texlive-latex-extra
Standards-Version: 3.9.6
Homepage: http://www.psicode.org/
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/psi4/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/psi4/

Package: psi4
Architecture: any
Depends: psi4-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Quantum Chemical Program Suite
 PSI4 is an ab-initio quantum chemistry program.  It is especially designed to
 accurately compute properties of small to medium molecules using highly
 correlated techniques. PSI4 is the parallelized successor of PSI3 and includes
 many state-of-the-art theoretical methods.
 .
 It can compute energies and gradients for the following methods:
  * Restricted, unrestricted and general restricted open shell Hartree-Fock
    (RHF/ROHF)
  * Restricted, unrestricted and general restricted open shell
    Densitry-Functional Theory, including density-fitting (DF-DFT)
  * Density Cumulant Functional Theory (DCFT)
  * Closed-shell Density-fitted Moeller-Plesset perturbation theory (DF-MP2)
  * Unrestricted Moeller-Plesset perturbation theory (MP2)
  * Orbital-Optimized MP2 theory (OMP2)
  * Third order Moeller-Plesset perturbation theory (MP3)
  * Orbital-Optimized MP3 theory (OMP3)
  * Coupled-cluster singles doubles (CCSD)
  * Coupled-cluster singles doubles with perturbative triples (CCSD(T))
    (only for unrestricted (UHF) reference wavefunctions)
  * Equation-of-motion coupled-cluster singles doubles (EOM-CCSD)
 .
 Additionally, it can compute energies for the following methods:
  * Closed/open shell Moeller-Plesset perturbation theory (MP2)
  * Spin-component scaled MP2 theory (SCS-MP2)
  * Fourth order Moeller-Plesset perturbation theory (MP4)
  * Density-fitted symmetry-adapted perturbation theory (DF-SAPT)
  * Multireference configuration-interaction (MRCI)
  * Closed-shell Density-fitted coupled-cluster singles doubles (DF-CCSD)
  * Closed-shell Density-fitted Coupled-cluster singles doubles with
    perturbative triples (DF-CCSD(T))
  * Second/third-order approximate coupled-cluster singles doubles (CC2/CC3)
  * Mukherjee Multireference coupled-cluster singles doubles theory (mk-MRCCSD)
  * Mukherjee Multireference coupled-cluster singles doubles with perturbative
    triples theory (mk-MRCCSD(T))
  * Second order algebraic-diagrammatic construction theory (ADC(2))
  * Quadratic configuration interaction singles doubles (QCISD)
  * Quadratic configuration interaction singles doubles with perturbative
    triples (QCISD(T))
  * Density Matrix Renormalization Group SCF (DMRG-SCF) and CI (DMRG-CI)
 .
 Further features include:
  * Flexible, modular and customizable input format via python
  * Excited state calculations with the EOM-CC2/CC3, EOM-CCSD, ADC(2), MRCI and
    mk-MRCC methods
  * Utilization of molecular point-group symmetry to increase efficiency
  * Internal coordinate geometry optimizer
  * Harmonic frequencies calculations (via finite differences)
  * Potential surface scans 
  * Counterpoise correction
  * One-electron properties like dipole/quadrupole moments, transition dipole
    moments, natural orbitals occupations or electrostatic potential
  * Composite methods like complete basis set extrapolation or G2/G3

Package: psi4-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Quantum Chemical Program Suite (data files)
 PSI4 is an ab-initio quantum chemistry program.  It is especially designed to
 accurately compute properties of small to medium molecules using highly
 correlated techniques. PSI4 is the parallelized successor of PSI3 and includes
 many state-of-the-art theoretical methods.
 .
 This package contains data files and the HTML documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DEB_BUILD_MULTIARCH=$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

export OMPI_MCA_orte_rsh_agent=/bin/false

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean --builddirectory=builddir
	find $(CURDIR) -name "*.pyc" -delete
	$(RM) -r $(CURDIR)/builddir/tmp-scratch

override_dh_auto_configure:
	dh_auto_configure --builddirectory=builddir --  \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo	\
		-DENABLE_CHEMPS2=1			\
		-DEXPLICIT_LIBS="-lint -lderiv"		\
		-DCHEMPS2_ROOT=/usr

override_dh_auto_build:
	dh_auto_build --builddirectory=builddir
	(cd builddir/doc/sphinxman; $(MAKE) sphinxman)

override_dh_auto_install:
	dh_auto_install --builddirectory=builddir
	mkdir -p debian/tmp/usr/share/doc/psi4/examples
	cp -a builddir/doc/sphinxman/html $(CURDIR)/debian/tmp/usr/share/doc/psi4
	$(RM) debian/tmp/usr/share/psi/databases/*.pyc
	find debian/tmp/usr/share/psi/python -name "*.pyc" | xargs rm -f
	cp samples/example_psi4rc_file debian/tmp/usr/share/doc/psi4/psi4rc.example
	for i in tu1-h2o-energy tu2-ch2-energy tu3-h2o-opt tu4-h2o-freq \
	tu5-sapt castup1 scf1 scf2 scf3 scf5 scf-guess-read dft1 dfmp2-1 \
	cc1 cc2 cc3 cc4 cc8 cc8a cc12 \
	cc15 cc16 cc17 cc18 cc19 cc23 cc24 cc28 cc32 cc49 \
	fci-dipole cisd-h2o+-0 ci-multi \
	cisd-opt-fd rasci-h2o mpn-bh \
	mcscf1 sapt1 sad1 \
	psimrcc-sp1 mints1 mints2 matrix1 opt1 opt1-fd gibbs omp2-2 \
	omp3-1 omp2_5-2 ocepa1 fnocc2 fnocc4 \
	mp2_5-grad1 ocepa-grad2 omp2-grad1 \
	dcft1 dcft2 dcft3 dcft4 pywrap-db1 pywrap-db2 pywrap-cbs1 pywrap-all pywrap-alias \
	pywrap-checkrun-rhf pywrap-freq-e-sowreap; \
		do cp samples/$$i/input.dat \
		$(CURDIR)/debian/tmp/usr/share/doc/psi4/examples/$$i.dat; \
	done

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	mkdir -p $(CURDIR)/builddir/tmp-scratch
	-(cd builddir/tests; ctest -L quicktests)
	-(cd builddir/tests; ctest -L dmrg)
endif

=== debian/watch ===
version=3
https://github.com/psi4/psi4public/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|y(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
